import * as Promise from 'bluebird';
import { OrderedMap } from 'immutable';
import { Action, Dispatch } from 'pretur.redux';
import { Query, Synchronizer, Fetcher } from 'pretur.sync';
import StatusReporter from './StatusReporter';
import Record from './Record';
declare abstract class Set<T extends Record<TInsert>, TModel, TInsert> extends StatusReporter {
    private _original;
    protected _items: OrderedMap<number, T>;
    constructor(items?: TModel[], synchronized?: boolean);
    original: this;
    items: OrderedMap<number, T>;
    reduce(action: Action<any, any>): this;
    clear(dispatch: Dispatch): void;
    add(dispatch: Dispatch, values?: TModel): void;
    remove(dispatch: Dispatch, target: number): void;
    refresh(dispatch: Dispatch, query: Query, fetcher: Fetcher): Promise<void>;
    sync(dispatch: Dispatch, synchronizer: Synchronizer): void;
    appendSynchronizationModels(synchronizer: Synchronizer): void;
    buildInsertModel(): TInsert[];
    protected checkValidity(): boolean;
    protected cloneOverride(clone: this): void;
    protected abstract constructItem(synchronized?: boolean, values?: TModel): T;
}
export default Set;
